# Typstuff, stuff I made with Typst <!-- omit from toc -->

This repository lists some of the stuff I have made using Typst

Smaller scripts will be included directly in this repository

---

### Table of contents <!-- omit from toc -->

- [RIVET](#rivet)
- [Chronos](#chronos)
- [Circuiteria](#circuiteria)
- [Functastic](#functastic)
- [Math tools](#math-tools)
- [Sankeynoa](#sankeynoa)
- [RISCV Utilities](#riscv-utilities)
- [Simple UML class diagrams](#simple-uml-class-diagrams)
- [Tasty TacOS](#tasty-tacos)
- [Leetcode trees](#leetcode-trees)
- [Cafeteria menus](#cafeteria-menus)
- [Avent of Code](#avent-of-code)


## RIVET
*Links*:
[Repo](https://git.kb28.ch/HEL/rivet-typst) /
[Universe](https://typst.app/universe/package/rivet)

*Description*:
Register / Instruction Visualizer & Explainer Tool with Typst, using CeTZ

<p align="center">
    <img src="images/rivet.png" width="400">
</p>

## Chronos
*Links*:
[Repo](https://git.kb28.ch/HEL/chronos) /
[Universe](https://typst.app/universe/package/chronos)

*Description*:
A Typst package to draw sequence diagrams with CeTZ

<p align="center">
    <img src="images/chronos.png" width="150">
</p>

## Circuiteria
*Links*:
[Repo](https://git.kb28.ch/HEL/circuiteria) /
[Universe](https://typst.app/universe/package/circuiteria)

*Description*:
Drawing block circuits with Typst made easy, using CeTZ

<p align="center">
    <img src="images/circuiteria.png" width="300">
</p>

## Functastic
*Links*:
[Repo](https://git.kb28.ch/HEL/functastic)

*Description*:
A Typst package to create sign tables of mathematical functions

<p align="center">
    <img src="images/functastic.png" width="400">
</p>

## Math tools
*Links*:
[Repo](https://git.kb28.ch/HEL/math-tools)

*Description*:
Useful mathematical functions

<p align="center">
    <img src="images/math_tools.png" width="400">
</p>

## Sankeynoa
*Links*:
[Repo](https://git.kb28.ch/HEL/sankeynoa)

*Description*:
Beautiful Sankey diagrams using CeTZ

<p align="center">
    <img src="images/sankeynoa.png" width="400">
</p>

## RISCV Utilities
*Links*:
[Directory](./misc/riscv/)

*Description*:
Some RISCV utilities to show instructions

<p align="center">
    <img src="images/riscv.png" width="500">
</p>

## Simple UML class diagrams
*Links*:
[Directory](./misc/uml/)

*Description*:
Functions do make simple class diagrams and directly parse UML

<p align="center">
    <img src="images/uml.png" width="400">
</p>

## Tasty TacOS
*Links*:
[Repo](https://git.kb28.ch/HEL/tasty-tacos)

*Description*:
Various algorithms from the OS course

<p align="center">
    <img src="images/tasty_tacos.png" width="500">
</p>

## Leetcode trees
*Links*:
[Directory](./misc/leetcode_trees/)

*Description*:
Function to easily display leetcode tree exercises in a CeTZ canvas

<p align="center">
    <img src="images/leetcode_trees.png" width="300">
</p>

## Cafeteria menus
*Links*:
[Directory](./misc/menus/)

*Description*:
Cafeteria menus for the week, used by a Discord and a Telegram bot

<p align="center">
    <img src="images/menus.png" width="500">
</p>

## Avent of Code
*Links*:
[Repo](https://git.kb28.ch/HEL/AdventOfCode2024)

*Description*:
My attempt at Advent of Code (2024)

<p align="center">
    <img src="images/aoc.png" width="300">
</p>



